var wpvmachine_imgs = {};
var wpvmachine_selected = new Array();
var wpvmachine_opened = false;
var wpvmachine_page = 1;
var wpvmachine_current = '';
var wpvmachine_width_small = '630px';
var wpvmachine_width_big = '930px';
var wpvmachine_height = '610px';

jQuery( document ).ready( function( $ ) {
	$( 'body' ).on( 'click touch', '#wpvmachine_search', function() {
		wpvmachine_page = 1;
		wpvmachine_show_images( 1 );
	} );

	$( 'body' ).on( 'click touch', '#wpvmimg-next', function() {
		wpvmachine_page++;
		wpvmachine_show_images( wpvmachine_page );
	} );
	
	$( 'body' ).on( 'click touch', '#wpvmimg-prev', function() {
		wpvmachine_page--;
		wpvmachine_show_images( wpvmachine_page );
	} );


	$( 'body' ).on( 'click touch', '.wpvmachine_btn', function() {
		var eid = $( this ).attr( 'data-editor' );
		$( '#wpvmachine_eid' ).val( eid );

		/*if ( wpvmachine_opened ) {
			$.colorbox( {
				width: wpvmachine_width_big,
				height: wpvmachine_height,
				inline: true,
				href: '#wpvmachine_area',
				scrolling: false,
				fixed: true
			} );
		} else {
			$.colorbox( {
				width: wpvmachine_width_small,
				height: wpvmachine_height,
				inline: true,
				href: '#wpvmachine_area',
				scrolling: false,
				fixed: true
			} );
		}*/
	} );

	$( 'body' ).on( 'click touch', '#wpvmachine_page a', function() {
		$( '#wpvmachine_page' ).html( '' );
		wpvmachine_show_images( $( this ).attr( 'rel' ) );
	} );

	$( 'body' ).on( 'change', '#wpvmachine_page_select', function() {
		wpvmachine_show_images( $( this ).val() );
	} );

	$( 'body' ).on( 'click touch', '#wpvmachine_insert', function() {
		for ( var i = 0; i < wpvmachine_selected.length; i ++ ) {
			var insert = '';
			var align = '';
			var align2 = '';
			var eid = $( '#wpvmachine_eid' ).val();
			if ( $( '#wpvmachine_align' ).val() != '' ) {
				align = ' align="' + wpvmachine_esc_html( $( '#wpvmachine_align' ).val() ) + '"';
				align2 = ' class="' + wpvmachine_esc_html( $( '#wpvmachine_align' ).val() ) + '"';
			}
			var sid = wpvmachine_selected[i];
			if ( wpvmachine_imgs[sid].img_caption != '' ) {
				insert = '[caption id="" ' + align + ']';
			}
			if ( $( '#wpvmachine_link' ).val() == 1 ) {
				insert += '<a href="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_site ) + '" title="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_title ) + '"';
			}
			if ( $( '#wpvmachine_link' ).val() == 2 ) {
				insert += '<a href="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_full ) + '" title="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_title ) + '"';
			}
			if ( (
				     $( '#wpvmachine_link' ).val() != 0
			     ) && $( '#wpvmachine_blank' ).is( ':checked' ) ) {
				insert += ' target="_blank"';
			}
			if ( (
				     $( '#wpvmachine_link' ).val() != 0
			     ) && $( '#wpvmachine_nofollow' ).is( ':checked' ) ) {
				insert += ' rel="nofollow"';
			}
			if ( $( '#wpvmachine_link' ).val() != 0 ) {
				insert += '>';
			}
			insert += '<img ' + align2 + ' src="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_full ) + '" width="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_width.toString() ) + '" height="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_height.toString() ) + '" title="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_title ) + '" alt="' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_title ) + '"/>';
			if ( $( '#wpvmachine_link' ).val() != 0 ) {
				insert += '</a>';
			}
			if ( wpvmachine_imgs[sid].img_caption != '' ) {
				insert += ' ' + wpvmachine_esc_html( wpvmachine_imgs[sid].img_caption ) + '[/caption]';
			}
			insert += '\n';
			if ( ! tinyMCE.activeEditor || tinyMCE.activeEditor.isHidden() ) {
				wpvmachine_insert_caret( eid, insert );
			} else {
				tinyMCE.activeEditor.execCommand( 'mceInsertContent', 0, insert );
			}
		}
		// $.colorbox.close();
	} );

	$( 'body' ).on( 'click touch', '#wpvmachine_featured', function() {
		var url = $( '#wpvmachine_url' ).val();
		var title = $( '#wpvmachine_title' ).val();
		var caption = $( '#wpvmachine_caption' ).val();

		$( '.wpvmachine_featured_url' ).val( url );
		$( '.wpvmachine_featured_title' ).val( title );
		$( '.wpvmachine_featured_caption' ).val( caption );

		//fix for pexels
		$( '.wppx_featured_url' ).val( url );
		$( '.wppx_featured_title' ).val( title );
		$( '.wppx_featured_caption' ).val( caption );

		$( '#postimagediv div.inside img' ).remove();
		$( '#postimagediv div.inside' ).prepend( '<img src="' + url + '" width="270"/>' );
		// $.colorbox.close();
	} );

	$( 'body' ).on( 'click touch', '#remove-post-thumbnail', function() {
		$( '.wpvmachine_featured_url' ).val( '' );
		//fix for pexels
		$( '.wppx_featured_url' ).val( '' );
	} );

	$( 'body' ).on( 'click touch', '.wpvmachine_item_overlay', function( event ) {
		var parent = $( this ).parent();
		var checkbox = parent.find( ':checkbox' );
		var checkbox_id = $( this ).attr( 'rel' );

		// $.colorbox.resize( {width: wpvmachine_width_big, height: wpvmachine_height} );
		wpvmachine_opened = true;
		wpvmachine_current = checkbox_id;

		// if ( event.ctrlKey ) {
			var full_img = parent.attr( 'data-full' )
			if ( ! checkbox.is( ':checked' ) ) {
				wpvmachine_selected.push( /*checkbox_id*/full_img );
				parent.addClass( 'selected' )
			} else {
				wpvmachine_selected.splice( wpvmachine_selected.indexOf( /*checkbox_id*/full_img ), 1 );
				parent.removeClass( 'selected' )
			}

			checkbox.attr( 'checked', ! checkbox.is( ':checked' ) );
		/*} else {
			if ( ! checkbox.is( ':checked' ) ) {
				wpvmachine_selected = [checkbox_id];
				$( '#wpvmachine_area' ).find( 'input:checkbox' ).removeAttr( 'checked' );
				checkbox.attr( 'checked', ! checkbox.is( ':checked' ) );
			}
		}*/

		$( '#wpvmachine_use-image' ).show();
		$( '#wpvmachine_title' ).val( wpvmachine_imgs[checkbox_id].img_title );
		$( '#wpvmachine_caption' ).val( wpvmachine_imgs[checkbox_id].img_caption );
		$( '#wpvmachine_width' ).val( wpvmachine_imgs[checkbox_id].img_width );
		$( '#wpvmachine_height' ).val( wpvmachine_imgs[checkbox_id].img_height );
		$( '#wpvmachine_url' ).val( wpvmachine_imgs[checkbox_id].img_full );
		$( '#wpvmachine_view' ).html( '<img src="' + wpvmachine_imgs[checkbox_id].img_full + '"/>' );
		$( '#wpvmachine_error' ).html( '' );

		// add count
		jQuery( '#wpvmachine_insert span' ).html( '(' + wpvmachine_selected.length + ')' );
		jQuery( '#wpvmachine_save span' ).html( '(' + wpvmachine_selected.length + ')' );
		jQuery( '#wpvmachine_save_only span' ).html( ' (' + wpvmachine_selected.length + ')' );
	} );

	$( 'body' ).on( 'change', '#wpvmachine_title', function() {
		wpvmachine_change_value( wpvmachine_current, 'img_title', $( this ).val() );
	} );

	$( 'body' ).on( 'change', '#wpvmachine_caption', function() {
		wpvmachine_change_value( wpvmachine_current, 'img_caption', $( this ).val() );
	} );

	$( 'body' ).on( 'change', '#wpvmachine_width', function() {
		wpvmachine_change_value( wpvmachine_current, 'img_width', $( this ).val() );
	} );

	$( 'body' ).on( 'change', '#wpvmachine_height', function() {
		wpvmachine_change_value( wpvmachine_current, 'img_height', $( this ).val() );
	} );

	$( 'body' ).on( 'click', '#wpvmachine_use_imgs', function( e ) {
		e.preventDefault();
		if( wpvmachine_selected.length == 0 ) {
			alert( 'No Image/s selected' )
			return;
		}
		var n_images = wpvmachine_selected.length;
		for( i=0;i<n_images;i++)
		// console.log(wpvmachine_selected);
			window.top.wpvmachine_append_img( wpvmachine_selected[i] )
			jQuery( '#wpvmachine_container' ).html( '' );
			jQuery( '#wpvmachine_page' ).html( '' );
			jQuery( '#wpvmachine_view' ).html( '' );
			jQuery( '#wpvmachine_input' ).val( '' );
			jQuery( '#wpvmachine_title' ).val( '' );

			wpvmachine_selected = Array();
			// console.log(window.top.wp)
			// console.log(window.top.wp.media)
			window.top.wp.media.frame.close();
			// window.top.wp.media.editor.remove();
			// console.log(window.top.wp.media.frames)
			// window.top.wp.media.close();
		// wpvmachine_change_value( wpvmachine_current, 'img_height', $( this ).val() );
	} );
	
} );



function wpvmachine_show_images( page ) {
	if ( jQuery( '#wpvmachine_input' ).val() == '' ) {
		alert( 'Please enter a keyword' );
	} else {
		var wpvmachine_url = '';
		// var wpvmachine_key = wpvmachine_vars.wpvmachine_key;
		var wpvmachine_number = 25;
/*		var wpvmachine_hires = jQuery( '#wpvmachine_hires' ).val();
		if ( wpvmachine_hires != 'no' ) {
			wpvmachine_url = "https://pixabay.com/api/?response_group=high_resolution&key=" + wpvmachine_key + "&lang=" + jQuery( '#wpvmachine_language' ).val() + "&category=" + jQuery( '#wpvmachine_category' ).val() + "&image_type=" + jQuery( '#wpvmachine_type' ).val() + "&orientation=" + jQuery( '#wpvmachine_orientation' ).val() + "&editors_choice=" + jQuery( '#wpvmachine_editorchoice' ).val() + "&order=" + jQuery( '#wpvmachine_order' ).val() + "&safesearch=" + jQuery( '#wpvmachine_safesearch' ).val() + "&q=" + encodeURIComponent( jQuery( '#wpvmachine_input' ).val() ) + "&per_page=" + wpvmachine_number + "&page=" + page;
		} else {
			wpvmachine_url = "https://pixabay.com/api/?key=" + wpvmachine_key + "&lang=" + jQuery( '#wpvmachine_language' ).val() + "&category=" + jQuery( '#wpvmachine_category' ).val() + "&image_type=" + jQuery( '#wpvmachine_type' ).val() + "&orientation=" + jQuery( '#wpvmachine_orientation' ).val() + "&editors_choice=" + jQuery( '#wpvmachine_editorchoice' ).val() + "&order=" + jQuery( '#wpvmachine_order' ).val() + "&safesearch=" + jQuery( '#wpvmachine_safesearch' ).val() + "&q=" + encodeURIComponent( jQuery( '#wpvmachine_input' ).val() ) + "&per_page=" + wpvmachine_number + "&page=" + page;
		}*/
		jQuery( '#wpvmachine_search' ).addClass( 'loading' );
		jQuery( '#wpvmachine_container' ).html( '' );
		jQuery( '#wpvmachine_page' ).html( 'Page '+ page );

		 // + "&per_page=" + wpvmachine_number + "&page=" + page

		var data = {
		    action: 'wpvmachine_search_images',
		    keyword : encodeURIComponent( jQuery( '#wpvmachine_input' ).val() ),
		    per_page : wpvmachine_number,
		    page : page
		};

		jQuery.post(ajaxurl, data, function( response ) {

			var ret = jQuery.parseJSON( response );
			data.hits = ret;
			// console.log(ret);
			jQuery( '#wpvmachine_search' ).removeClass( 'loading' );

			if ( 1 ) {
				for ( var i = 0; i < data.hits.length; i ++ ) {
					img_id = data.hits[i].id;
					img_ext = data.hits[i].fullsize_url.split( '.' ).pop().toUpperCase().substring( 0, 4 );
					img_thumb = data.hits[i].thumbnail_url;
					/*if ( data.hits[i].hasOwnProperty( 'pageURL' ) ) {
						img_site = data.hits[i].pageURL;
					} else {
						img_site = 'https://pixabay.com';
					}*/
					img_site = 'https://pixabay.com';
					img_title = data.hits[i].title;
					img_caption = '';
					/*if ( data.hits[i].hasOwnProperty( 'tags' ) ) {
						img_title = String( data.hits[i].tags );
					} else if ( data.hits[i].hasOwnProperty( 'user' ) ) {
						img_title = data.hits[i].user + ' (CC0), Pixabay';
					} else {
						img_title = '';
					}
					if ( data.hits[i].hasOwnProperty( 'user' ) ) {
						img_caption = data.hits[i].user + ' (CC0), Pixabay';
					} else {
						img_caption = '';
					}*/

					img_full = data.hits[i].fullsize_url;
					img_width = data.hits[i].width;
					img_height = data.hits[i].height;

					/*if ( (
						     wpvmachine_hires == 'large'
					     ) && data.hits[i].hasOwnProperty( 'largeImageURL' ) ) {
						img_id = data.hits[i].id_hash;
						img_full = data.hits[i].largeImageURL;
						img_width = 1280;
						img_height = '';
						img_site = 'https://pixabay.com/goto/' + img_id;
					}

					if ( (
						     wpvmachine_hires == 'fullhd'
					     ) && data.hits[i].hasOwnProperty( 'fullHDURL' ) ) {
						img_id = data.hits[i].id_hash;
						img_full = data.hits[i].fullHDURL;
						img_width = 1920;
						img_height = '';
						img_site = 'https://pixabay.com/goto/' + img_id;
					}

					if ( (
						     wpvmachine_hires == 'original'
					     ) && data.hits[i].hasOwnProperty( 'imageURL' ) ) {
						img_id = data.hits[i].id_hash;
						img_full = data.hits[i].imageURL;
						img_width = data.hits[i].imageWidth;
						img_height = data.hits[i].imageHeight;
						img_site = 'https://pixabay.com/goto/' + img_id;
					}*/
					if ( img_height != '' ) {
						jQuery( '#wpvmachine_container' ).append( '<div class="wpvmachine_item" data-full="'+img_full+'" bg="' + img_thumb + '"><div class="wpvmachine_item_overlay" rel="' + img_id + '"></div><div class="wpvmachine_check"><input type="checkbox" value="' + img_id + '"/></div><span>' +
						                                    img_ext + ' | ' + img_width + ' x ' + img_height + '</span></div>' );
					} else {
						jQuery( '#wpvmachine_container' ).append( '<div class="wpvmachine_item" data-full="'+img_full+'" bg="' + img_thumb + '"><div class="wpvmachine_item_overlay" rel="' + img_id + '"></div><div class="wpvmachine_check"><input type="checkbox" value="' + img_id + '"/></div><span>' +
						                                    img_ext + ' | ' + img_width + '</span></div>' );
					}
					wpvmachine_imgs[img_id] = {
						img_ext: img_ext,
						img_site: img_site,
						img_thumb: img_thumb,
						img_full: img_full,
						img_width: img_width,
						img_height: img_height,
						img_title: img_title,
						img_caption: img_caption
					};
				}

				jQuery( '.wpvmachine_item' ).each( function() {
					imageUrl = jQuery( this ).attr( 'bg' );
					jQuery( this ).css( 'background-image', 'url(' + imageUrl + ')' );
				} );
/*
				var vpages = "About " + data.totalHits + " results / Pages: ";

				if ( (
					     data.totalHits / wpvmachine_number + 1
				     ) < 10 ) {
					for ( var j = 1; j < data.totalHits / wpvmachine_number + 1; j ++ ) {
						vpages += '<a href="javascript: void (0);" rel="' + j + '" title="Page ' + j + '">' + j + '</a> ';
					}
				} else {
					vpages += '<select id="wpvmachine_page_select" class="wpvmachine_page_select">';
					for ( var j = 1; j < data.totalHits / wpvmachine_number + 1; j ++ ) {
						vpages += '<option value="' + j + '"';
						if ( j == page ) {
							vpages += ' selected';
						}
						vpages += '>' + j + '</option> ';
					}
					vpages += '</select>';
				}

				jQuery( '#wpvmachine_page' ).html( vpages );*/
				var str_page = '<span style="display:inline-block;vertical-align:middle;margin-left:10px;margin-right:10px">Page '+ page+'</span>';
				if( page > 1 )
					str_page += '<button type="button" class="button button-secondary" id="wpvmimg-prev" style="display:inline-block;vertical-align:middle;margin-left:10px;margin-right:10px">< Prev</button>';
				str_page += '<button type="button" class="button button-secondary" id="wpvmimg-next" style="display:inline-block;vertical-align:middle;margin-left:10px;margin-right:10px">Next ></button>';
				jQuery( '#wpvmachine_page' ).html( str_page );
			} else {
				jQuery( '#wpvmachine_container' ).html( 'No result! Please try again!' );
				jQuery( '#wpvmachine_page' ).html( '' );
			}

		    // jQuery('#wpbl-keywords').val(response);
		    // var ret = jQuery.parseJSON(response);
		    // if( ret.result == 1 ) {
		    //     var tags = ret.tags;
		    //     var n_tags = tags.length;
		    //     for( i= 0; i< n_tags; i++ )
		    //         jQuery('#wpvmachine_youtube_tags').tagEditor( 'addTag', tags[i] );
		    // }
		});
		/*jQuery.ajax( {
			url: wpvmachine_url,
			dataType: 'jsonp',
			success: function( data ) {
				console.log(data)
				jQuery( '#wpvmachine_search' ).removeClass( 'loading' );
				if ( data.totalHits > 0 ) {
					for ( var i = 0; i < data.hits.length; i ++ ) {
						img_id = data.hits[i].id;
						img_ext = data.hits[i].webformatURL.split( '.' ).pop().toUpperCase().substring( 0, 4 );
						img_thumb = data.hits[i].previewURL;
						if ( data.hits[i].hasOwnProperty( 'pageURL' ) ) {
							img_site = data.hits[i].pageURL;
						} else {
							img_site = 'https://pixabay.com';
						}
						if ( data.hits[i].hasOwnProperty( 'tags' ) ) {
							img_title = String( data.hits[i].tags );
						} else if ( data.hits[i].hasOwnProperty( 'user' ) ) {
							img_title = data.hits[i].user + ' (CC0), Pixabay';
						} else {
							img_title = '';
						}
						if ( data.hits[i].hasOwnProperty( 'user' ) ) {
							img_caption = data.hits[i].user + ' (CC0), Pixabay';
						} else {
							img_caption = '';
						}

						img_full = data.hits[i].webformatURL;
						img_width = data.hits[i].webformatWidth;
						img_height = data.hits[i].webformatHeight;

						if ( (
							     wpvmachine_hires == 'large'
						     ) && data.hits[i].hasOwnProperty( 'largeImageURL' ) ) {
							img_id = data.hits[i].id_hash;
							img_full = data.hits[i].largeImageURL;
							img_width = 1280;
							img_height = '';
							img_site = 'https://pixabay.com/goto/' + img_id;
						}

						if ( (
							     wpvmachine_hires == 'fullhd'
						     ) && data.hits[i].hasOwnProperty( 'fullHDURL' ) ) {
							img_id = data.hits[i].id_hash;
							img_full = data.hits[i].fullHDURL;
							img_width = 1920;
							img_height = '';
							img_site = 'https://pixabay.com/goto/' + img_id;
						}

						if ( (
							     wpvmachine_hires == 'original'
						     ) && data.hits[i].hasOwnProperty( 'imageURL' ) ) {
							img_id = data.hits[i].id_hash;
							img_full = data.hits[i].imageURL;
							img_width = data.hits[i].imageWidth;
							img_height = data.hits[i].imageHeight;
							img_site = 'https://pixabay.com/goto/' + img_id;
						}
						if ( img_height != '' ) {
							jQuery( '#wpvmachine_container' ).append( '<div class="wpvmachine_item" bg="' + img_thumb + '"><div class="wpvmachine_item_overlay" rel="' + img_id + '"></div><div class="wpvmachine_check"><input type="checkbox" value="' + img_id + '"/></div><span>' +
							                                    img_ext + ' | ' + img_width + ' x ' + img_height + '</span></div>' );
						} else {
							jQuery( '#wpvmachine_container' ).append( '<div class="wpvmachine_item" bg="' + img_thumb + '"><div class="wpvmachine_item_overlay" rel="' + img_id + '"></div><div class="wpvmachine_check"><input type="checkbox" value="' + img_id + '"/></div><span>' +
							                                    img_ext + ' | ' + img_width + '</span></div>' );
						}
						wpvmachine_imgs[img_id] = {
							img_ext: img_ext,
							img_site: img_site,
							img_thumb: img_thumb,
							img_full: img_full,
							img_width: img_width,
							img_height: img_height,
							img_title: img_title,
							img_caption: img_caption
						};
					}

					jQuery( '.wpvmachine_item' ).each( function() {
						imageUrl = jQuery( this ).attr( 'bg' );
						jQuery( this ).css( 'background-image', 'url(' + imageUrl + ')' );
					} );

					var vpages = "About " + data.totalHits + " results / Pages: ";

					if ( (
						     data.totalHits / wpvmachine_number + 1
					     ) < 10 ) {
						for ( var j = 1; j < data.totalHits / wpvmachine_number + 1; j ++ ) {
							vpages += '<a href="javascript: void (0);" rel="' + j + '" title="Page ' + j + '">' + j + '</a> ';
						}
					} else {
						vpages += '<select id="wpvmachine_page_select" class="wpvmachine_page_select">';
						for ( var j = 1; j < data.totalHits / wpvmachine_number + 1; j ++ ) {
							vpages += '<option value="' + j + '"';
							if ( j == page ) {
								vpages += ' selected';
							}
							vpages += '>' + j + '</option> ';
						}
						vpages += '</select>';
					}

					jQuery( '#wpvmachine_page' ).html( vpages );
				} else {
					jQuery( '#wpvmachine_container' ).html( 'No result! Please try again!' );
					jQuery( '#wpvmachine_page' ).html( '' );
				}
			}
		} );*/
	}
}

function wpvmachine_is_url( str ) {
	var pattern = new RegExp( '^(https?:\\/\\/)?' + // protocol
	                          '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.?)+[a-z]{2,}|' + // domain name
	                          '((\\d{1,3}\\.){3}\\d{1,3}))' + // OR ip (v4) address
	                          '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*' + // port and path
	                          '(\\?[;&a-z\\d%_.~+=-]*)?' + // query string
	                          '(\\#[-a-z\\d_]*)?$', 'i' ); // fragment locator
	return pattern.test( str );
}

function wpvmachine_change_value( img_id, img_field, img_value ) {
	wpvmachine_imgs[img_id][img_field] = img_value;
}

function wpvmachine_insert_caret( areaId, text ) {
	var txtarea = document.getElementById( areaId );
	var scrollPos = txtarea.scrollTop;
	var strPos = 0;
	var br = (
		(
			txtarea.selectionStart || txtarea.selectionStart == '0'
		) ?
			"ff" : (
				document.selection ? "ie" : false
			)
	);
	if ( br == "ie" ) {
		txtarea.focus();
		var range = document.selection.createRange();
		range.moveStart( 'character', - txtarea.value.length );
		strPos = range.text.length;
	}
	else if ( br == "ff" ) {
		strPos = txtarea.selectionStart;
	}

	var front = (
		txtarea.value
	).substring( 0, strPos );
	var back = (
		txtarea.value
	).substring( strPos, txtarea.value.length );
	txtarea.value = front + text + back;
	strPos = strPos + text.length;
	if ( br == "ie" ) {
		txtarea.focus();
		var range = document.selection.createRange();
		range.moveStart( 'character', - txtarea.value.length );
		range.moveStart( 'character', strPos );
		range.moveEnd( 'character', 0 );
		range.select();
	}
	else if ( br == "ff" ) {
		txtarea.selectionStart = strPos;
		txtarea.selectionEnd = strPos;
		txtarea.focus();
	}
	txtarea.scrollTop = scrollPos;
}

function wpvmachine_esc_html( html ) {
	var fn = function( tag ) {
		var charsToReplace = {
			'&': '&amp;',
			'<': '&lt;',
			'>': '&gt;',
			'"': '&#34;'
		};
		return charsToReplace[tag] || tag;
	}
	if ( typeof html !== 'string' ) {
		return '';
	} else {
		return html.replace( /[&<>"]/g, fn );
	}
}