<?php
define( 'WPVMACHINE_PEXELS_URL', 'https://api.pexels.com/v1/search' );

function wpvmachine_pexels_imagesearch( $search_term, $page=1, $results_per_page=36, $offset=0  ) {
    $attribution_required=0;
    $imgtype=0;
    $only_modifiables = 0;
    // global $wpbeautify_sites;
    $search_term = str_replace( ' ', '+', $search_term );
/*
    $image_settings = wpbeautify_get_image_settings();
    $wpbeautify_sites = $image_settings['image_sites'];

    if ( isset( $wpbeautify_sites['pexels']['details']['onlynoattribution'] ) && $wpbeautify_sites['pexels']['details']['onlynoattribution'] == 1 )
        $pexels_licenses = '7,8';
    else {
        if ($only_modifiables)
            $pexels_licenses = '2,4,5,7,8';
        else
            $pexels_licenses = '2,3,4,5,6,7,8';
    }

    if ( $attribution_required == 2 ) {
        if ($only_modifiables)
            $pexels_licenses = '2,4,5';
        else
            $pexels_licenses = '2,3,4,5,6';
    }
    else if ( $attribution_required == 1 )
        $pexels_licenses = '7,8';*/

    $pexels_licenses = '2,3,4,5,6';
// var_dump($pexels_licenses);
    // if ($only_modifiables)
//        $pexels_licenses = array_diff($pexels_licenses, array(3,6));
    if ( $offset )
        if ( $page > 1 ) $page--;

    if ( $imgtype == 2 )
        $content_type = 1;
    else if ( $imgtype == 1 )
        $content_type = 3;
    else
        $content_type = 7;

        $req_args = array(
            'per_page'       => $results_per_page,
            'page'           => $page,
            'query'           => $search_term,
        );

        $headers = array(
            'Authorization: 563492ad6f91700001000001b1af0f0e9d3f41a6972ba00fca22ca5d'
        );
    // @TODO: investigar iscommons = 1
    //http://www.pexels.com/services/api/pexels.photos.search.html

    if ( !$offset ) {
        $url = add_query_arg( $req_args, WPVMACHINE_PEXELS_URL );
        // echo $url;
        $response = remote_get( $url, $headers );
        // var_dump($response);
        // var_dump($response);
        if ( !( $response ) ) {
            return 0;
        } else {
            // var_dump($response['body']);
            return wpbeautify_pexels_togeneric ( json_decode( $response, true ), $offset, $results_per_page );
        }
    }
    else {
        $response = remote_get( add_query_arg( $req_args, WPVMACHINE_PEXELS_URL ) );
        if ( !( $response ) ) {
            return 0;
        } else {
            $arr1 = wpbeautify_pexels_togeneric ( json_decode( $response, true ), $offset, $results_per_page );
            $req_args['page']++;
            $response = remote_get( add_query_arg( $req_args, WPVMACHINE_PEXELS_URL ) );
            if ( !( $response ) ) {
                return 0;
            } else {
                $arr2 = wpbeautify_pexels_togeneric ( json_decode( $response, true ), $offset, $results_per_page );
                $return_object = new stdClass();
                $return_object->total_images = $arr1->total_images; // + $arr2->total_images;
                $max_page = ( floor( $arr1->total_images / $results_per_page )+1 );
                if ( $req_args['page'] < $max_page )
                    $return_object->images = array_merge( $arr1->images, $arr2->images );
                else
                    $return_object->images = $arr1->images;

                $return_object->images = array_slice( $return_object->images, $offset, $results_per_page );
                $return_object->images_in_group = count( $return_object->images );
                return $return_object;
            }
        }

    }
}

/*
function wpbeautify_pexels_getimgsizes( $photo_id ) {
    $req_args = array(
        'photo_id'  => $photo_id,
        'api_key'   => '6295b7f50b317aadabbcf3e46e138fa5',
        'method'    => 'pexels.photos.getSizes',
        'format'    => 'php_serial'
    );

    $response = remote_get( add_query_arg( $req_args, WPVMACHINE_PEXELS_URL ) );
    if ( !( $response ) ) {
        echo 'Something went wrong!';
        return 0;
    }
    // TODO, si hay error, response es un WP_Error, y  da error
    $rsp_obj = ( $response );
    $sizes = $rsp_obj['sizes']['size'];
    while ( $size = array_shift( $sizes ) ) {
        if ( $size['label'] == 'Thumbnail' ) {
            $thumb_img = $size['source'];
        } // TODO: A veces Medium no es available!!!; use PICKAPIC_DEFAULT_PEXELS_IMG_SIZE instead.
        elseif ( $size['label'] == 'Medium' ) {
            $full_img = array( $size['source'], array( $size['width'], $size['height'] ) );
        }
        elseif ( $size['label'] == 'Original' ) {
            $full_img = array( $size['source'], array( $size['width'], $size['height'] ) );
        }
    }
    return array( $thumb_img, $full_img );
}

function wpbeautify_pexels_extrainfo( $photo_id ) {
    $req_args = array(
        'photo_id'  => $photo_id,
        'api_key'   => '6295b7f50b317aadabbcf3e46e138fa5',
        'method'    => 'pexels.photos.getInfo',
        'format'    => 'php_serial'
    );

    // http://www.pexels.com/services/api/pexels.photos.getSizes.html
    $response = remote_get( add_query_arg( $req_args, WPVMACHINE_PEXELS_URL ) );
    if ( !( $response ) ) {
        echo 'Something went wrong!';
        return 0;
    }
    // TODO, si hay error, response es un WP_Error, y  da error
    $rsp_obj = ( $response );
    return $rsp_obj;
}

function wpbeautify_pexels_authorinfo( $photo_id ) {
    $req_args = array(
        'user_id'  => $photo_id,
        'api_key'   => '6295b7f50b317aadabbcf3e46e138fa5',
        'method'    => 'pexels.urls.getUserProfile',
        'format'    => 'php_serial'
    );

    $response = remote_get( add_query_arg( $req_args, WPVMACHINE_PEXELS_URL ) );
    if ( !( $response ) ) {
        echo 'Something went wrong!';
        return 0;
    }
    // TODO, si hay error, response es un WP_Error, y  da error
    $rsp_obj = ( $response );
    return $rsp_obj;
}
*/

/*
    Object definition

total_images = num
images {
    thumbnail_url = url
    fullsize_url = url
    width = number
    height = number
    attribution = true/false
    author_name = name
    authour_url = url
}
*/

function wpvmachine_wpbeautify_pexels_togeneric( $images, $offset=0, $results_per_page=0 ) {
    // var_dump($images);
    $return_object = new stdClass();
    $return_object->total_images = $images['total_results'];
    $return_object->images = array();
 // var_dump($images['photos']);

    if ( !is_array( $images['photos'] ) ) return 0;
    foreach ( $images['photos'] as $hit ) {
// var_dump($hit['src']);
        $image = new stdClass();
        $image->thumbnail_url = $hit['url'];
        /*if ( isset( $hit['url_o'] ) ) {
            $image->fullsize_url = $hit['url_o'];
            $image->width = $hit['width_o'];
            $image->height = $hit['height_o'];
        }
        else if ( isset( $hit['url_l'] ) ) {
                $image->fullsize_url = $hit['url_l'];
                $image->width = $hit['width_l'];
                $image->height = $hit['height_l'];
            }
        else {
            $image->fullsize_url = $hit['url_m'];
            $image->width = $hit['width_m'];
            $image->height = $hit['height_m'];
        }*/

        $image->license_type = 1;

        $image->fullsize_url = $hit['src']['original'];
        $image->width = 0;
        $image->height = 0;

        // $image->author_url = null;
        // if ( $hit['license'] < 7 ) {
        //     $image->attribution = true; // TODO: review attribution policy in Flickr
        //     $image->author_url = 'http://www.pexels.com/people/'.$hit['pathalias'];
        // }
        // else
        //     $image->attribution = false; // TODO: review attribution policy in Flickr

        $image->modifiable = false;
        // $array_modifiables = array(2,4,5,7,8);
        // if (in_array($hit['license'], $array_modifiables ))
        //     $image->modifiable = true;

        $image->author_name =  $hit['photographer'];
        // $image->title = $hit['title'];
        $image->original_url = $hit['url'];
        $return_object->images[] = $image;
    }
    $return_object->images_in_group = count( $return_object->images );

    return $return_object;
}

/*function tsfpix_pexels_testapikey( $apikey ) {
    $req_args = array(
        'per_page'       => 10,
        'page'           => 1,
        'safe_search'    => 1,
        'content_type'   => 1,
        'privacy_filter' => 1, // Search for public photos
        'sort'           => 'relevance',
        'text'           => 'test',
        'media'          => 'photos',
        'api_key'        => $apikey,
        'method'         => 'pexels.photos.search',
        'format'         => 'php_serial',
    );

    $response = remote_get( add_query_arg( $req_args, WPVMACHINE_PEXELS_URL ) );
    if ( !( $response ) ) {
        return 0;
    } else {
        $results = ( $response );
        if ( !$results )
            return 0;
        if ( $results['stat'] != 'ok' )
            return 0;
        return 1;
    }
}*/
?>
