<?php
function wpvmachine_traffic_twitter( $url, $title ) {
	echo $url;
	/*var_dump($settings);
	if( empty( $settings ) )
		return false;*/
	$res = wpvmachine_share_twitter( '', $url, $title );
	// if( $res )
	// 	wpvmachine_log_traffic( $post_id, WPVMACHINE_TRAFFIC_TWITTER );
}

function wpvmachine_share_twitter( $text, $post_url, $title = '', $image_url = false ) {
	require_once WPVMACHINE_DIR.'/lib/libs/twitter/TwitterAPIExchange.php';
	$twitter_settings = wpvmachine_get_settings( array( 'social', 'twitter' ) );
// var_dump($twitter_settings);
	if ( ! isset( $twitter_settings['key'] ) || empty( $twitter_settings['key'] )
		|| ! isset( $twitter_settings['secret'] ) || empty( $twitter_settings['secret'] )
		|| ! isset( $twitter_settings['oauth_token'] ) || empty( $twitter_settings['oauth_token'] )
		|| ! isset( $twitter_settings['oauth_secret'] ) || empty( $twitter_settings['oauth_secret'] )
) {
		wpvmachine_debug( 'Error with Twitter Credentials', 'error' );
		return false;
	}

	$settings = array(
	    'consumer_key' => $twitter_settings['key'],
	    'consumer_secret' => $twitter_settings['secret'],
	    'oauth_access_token' => $twitter_settings['oauth_token'],
	    'oauth_access_token_secret' => $twitter_settings['oauth_secret'],
	);

	$media_id = 0;
	/*if( 1 && $image_url ) {
		$url = 'https://api.twitter.com/1.1/media/upload.json';
		$requestMethod = 'POST';
		$twitter = new TwitterAPIExchange( $settings );
		$code = $twitter->buildOauth( $url, $requestMethod )
		             ->setPostfields( $postfields )
		             ->performRequest();
	}*/

	$postfields = array(
	    'status' => $title.' '. $post_url
	);

	/*if( $media_id )
		$postfields['media_ids'] = $media_id;*/

	$url = 'https://api.twitter.com/1.1/statuses/update.json';
	$requestMethod = 'POST';
	$twitter = new TwitterAPIExchange( $settings );
	$code = $twitter->buildOauth( $url, $requestMethod )
	             ->setPostfields( $postfields )
	             ->performRequest();
	// var_dump($code);
	wpvmachine_debug( 'Shared on your Twitter Timeline', 'notice' );
	return true;
}
?>