<?php

	/* Menu */

	add_action ( 'admin_menu', 'wpvmachine_add_admin_menu' );

	/**
	 * add an option page attached with a setting submenu
	 */
	function wpvmachine_add_admin_menu() {
    // wpvmachine_set_invalid_api();
		if( wpvmachine_is_valid_api() ) {
			$page1 = add_menu_page('WP Video Machine', 'WP Video Machine', 'manage_options', 'wp-video-machine', 'wpvmachine_screen_log', WPVMACHINE_URL . '/img/logop.png');
      $page1 = add_submenu_page('wp-video-machine', 'Videos', 'Videos', 'manage_options', 'wp-video-machine', 'wpvmachine_screen_log');
      $page5 = add_submenu_page('wp-video-machine', 'New Video', 'New Video', 'manage_options', 'wp-video-machine-newvid', 'wpvmachine_screen_newvid');
			$page3 = add_submenu_page('wp-video-machine', 'Posts', 'Posts', 'manage_options', 'wp-video-machine-log', 'wpvmachine_screen1');
			$page2 = add_submenu_page('wp-video-machine', 'Settings', 'Settings', 'manage_options', 'wp-video-machine-settings', 'wpvmachine_screen_settings');
      $page4 = add_submenu_page('wp-video-machine', 'Help', 'Help', 'manage_options', 'wp-video-machine-support', 'wpvmachine_screen_help');
		}
		else {
			$page1 = add_menu_page('WP Video Machine', 'WP Video Machine', 'manage_options', 'wp-video-machine-settings', 'wpvmachine_screen_settings', WPVMACHINE_URL . '/img/logop.png');
      $page2 = add_submenu_page('wp-video-machine-settings', 'Settings', 'Settings', 'manage_options', 'wp-video-machine-settings', 'wpvmachine_screen_settings');
      $page4 = add_submenu_page('wp-video-machine-settings', 'Help', 'Help', 'manage_options', 'wp-video-machine-support', 'wpvmachine_screen_help');
    }

		add_action( "admin_print_scripts-$page1", 'wpvmachine_admin_scripts' );
		add_action( "admin_print_styles-$page1", 'wpvmachine_admin_style' );
    add_action( "admin_print_scripts-$page4", 'wpvmachine_admin_scripts' );
    add_action( "admin_print_styles-$page4", 'wpvmachine_admin_style' );
    add_action( "admin_print_scripts-$page2", 'wpvmachine_admin_scripts' );
    add_action( "admin_print_styles-$page2", 'wpvmachine_admin_style' );
		if( wpvmachine_is_valid_api() ) {
			add_action( "admin_print_scripts-$page3", 'wpvmachine_admin_scripts' );
			add_action( "admin_print_styles-$page3", 'wpvmachine_admin_style' );
      add_action( "admin_print_scripts-$page5", 'wpvmachine_admin_scripts' );
      add_action( "admin_print_styles-$page5", 'wpvmachine_admin_style' );
		}
	}

	function wpvmachine_admin_scripts() {

		wp_register_script( 'wpvmachine_admin_js', WPVMACHINE_URL . '/js/wpvmachine-admin.js', array('jquery'), WPVMACHINE_VERSION );

		$script_vars = array(
      'admin_url' => admin_url( 'admin.php' ),
			'log_url' => admin_url( 'admin.php?page=wp-video-machine-log' )
		);
		wp_localize_script( 'wpvmachine_admin_js', 'wpvmachine_vars', $script_vars );
		wp_enqueue_script( 'wpvmachine_admin_js');

		wp_register_script( 'wpvmachine-jquery-modal',
		        WPVMACHINE_URL . '/js/jquery.modal.js',
		        array( 'jquery' ) );
		wp_enqueue_script( 'wpvmachine-jquery-modal');

    wp_enqueue_script('jquery-ui-core');
    wp_enqueue_script('jquery-ui-sortable');

    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_script( 'wp-color-picker');


    // wp_enqueue_script('jquery-ui-datepicker');
    /*wp_enqueue_script( 'tiny_mce' );
    wp_enqueue_script('wp-tinymce');
    wp_enqueue_script('tinymce');
    wp_enqueue_script('editor');*/
    // add_action( 'admin_print_footer_scripts', 'wp_tiny_mce', 25 );
    wp_enqueue_media( );
	}

	function wpvmachine_admin_style() {
  		wp_register_style('wpvmachine_font_awesome_css', 'https://use.fontawesome.com/releases/v5.7.1/css/all.css', array(), WPVMACHINE_VERSION);
  	  	wp_enqueue_style('wpvmachine_font_awesome_css');

  	  	wp_register_style('wpvmachine_custom_css', WPVMACHINE_URL . '/css/wpvmachine-admin.css', array(), WPVMACHINE_VERSION);
  	  	wp_enqueue_style('wpvmachine_custom_css');
  	}


function wpvmachine_header() {
  echo '<img src="'.WPVMACHINE_URL.'/img/logo2.png" /><br/>';
}




  	function wpvmachine_post_type_selector( $val = 'post' ) {
  		$post_types = wpvmachine_get_post_types();
  		$str = '<select id="wpvm-post-types">';
  		if( $post_types ) {
  			// var_dump($post_types);
  			foreach( $post_types as $type ) {
  				if( $type->name == 'attachment' ) // Ignore Media
  					continue;
  				$str .= '<option value="'.$type->name.'" '.selected( $type->name, $val, false ).'>'.$type->label.'</option>';
  			}
  		}
  		$str .= '</select>';
  		echo $str;
  	}





?>