<?php
/* Traffic */

/* Traffic */
function wpvmachine_post_traffic( $post_id, $tags = array() ) {
    $settings = wpvmachine_get_plugin_settings();
    $settings = isset( $settings['import'] ) ? $settings['import'] : false;
    $shareauto = isset( $settings['shareauto'] ) ? intval( $settings['shareauto'] ) : 0;
    $bmachine = isset( $settings['bmachine'] ) ? intval( $settings['bmachine'] ) : 0;
    $blindexer = isset( $settings['blindexer'] ) ? intval( $settings['blindexer'] ) : 0;
    $ilindexer = isset( $settings['ilindexer'] ) ? intval( $settings['ilindexer'] ) : 0;
    $createvideo = isset( $settings['createvideo'] ) ? intval( $settings['createvideo'] ) : 0;

    @set_time_limit( 70 );
    if( $bmachine ) {
        // $bmachine_num = isset( $settings['bmachine_num'] ) ? intval( $settings['bmachine_num'] ) : 10;
// var_dump($tags);
        if( empty( $tags ) )
            $tags = array( 'review', 'internet marketing', 'product review', 'online marketing', 'make money on the internet' );
        else if( !is_array( $tags ) )
            $tags = explode( ',', $tags );
        $res = wpvmachine_blmachine_submit_job( get_permalink( $post_id ), $tags, 80 );
    }
    if( $shareauto ) {
        $sharingsites = isset( $settings['sharingsites'] ) ? ( $settings['sharingsites'] ) : array();

        if( isset( $sharingsites['facebook'] ) && $sharingsites['facebook'] )
            wpvmachine_traffic_facebook( $post_id );
        if( isset( $sharingsites['twitter'] ) && $sharingsites['twitter'] )
            wpvmachine_traffic_twitter( $post_id );
        if( isset( $sharingsites['medium'] ) && $sharingsites['medium'] )
            wpvmachine_traffic_medium( $post_id );
        if( isset( $sharingsites['tumblr'] ) && $sharingsites['tumblr'] )
            wpvmachine_traffic_tumblr( $post_id );
        if( isset( $sharingsites['linkedin'] ) && $sharingsites['linkedin'] )
            wpvmachine_traffic_linkedin( $post_id );
        if( isset( $sharingsites['buffer'] ) && $sharingsites['buffer'] )
            wpvmachine_traffic_buffer( $post_id );
    }
    if( $blindexer )
        wpvmachine_bli_submit_links_indexing( get_permalink( $post_id ) );
    if( $ilindexer )
        wpvmachine_ili_submit_links_indexing( get_permalink( $post_id ) );
    if( $createvideo ) {
        $title = wpvmachine_shorten_text( get_the_title( $post_id ), 88 );
        $content = wpvmachine_shorten_text( wpvmachine_get_content_by_id( $post_id ), 1800 );
        $content = html_entity_decode( strip_tags( $content ) );
        $images = array( );
        $thumb = wpvmachine_get_thumbnail( $post_id );
        if( $thumb )
            $images = array( $thumb );

        // $prod_name = get_post_meta( $post_id, '_wpvmachine_prodname', true );
        // if( !empty( $prod_name ) )
        //     $yt_title = $prod_name;
        // else
        //     $yt_title = $title;

        $youtube_description = 'More info at '.get_permalink( $post_id );
        $doc = new DOMDocument();
        @$doc->loadHTML(wpvmachine_get_content_by_id( $post_id ));
        $tags = $doc->getElementsByTagName('img');
        foreach ($tags as $tag) {
               $src = $tag->getAttribute('src');
               $images[] = $src;
        }
        wpvmachine_wpavmaker_submit_job( $title, $content, $images, 'en-us', 1, $title, $youtube_description );
    }
}

function wpvmachine_share_link_ajax() {
    $url = trim( $_POST['url'] );
    $title = trim( $_POST['title'] );
    if( !$url )
        exit();
    $networks =  $_POST['networks'];
    // var_dump($networks);
    foreach( $networks as $key => $network ) {
        if( ($key == 0 ) && $network )
            wpvmachine_traffic_facebook( $url, $title );
        if( ($key == 1 ) && $network )
            wpvmachine_traffic_twitter( $url, $title );
        if( ($key == 2 ) && $network )
            wpvmachine_traffic_medium( $url, $title );
        if( ($key == 3 ) && $network )
            wpvmachine_traffic_tumblr( $url, $title );
        if( ($key == 4 ) && $network )
            wpvmachine_traffic_linkedin( $url, $title );
        if( ($key == 5 ) && $network )
            wpvmachine_traffic_buffer( $url, $title );
    }
    // if( $post_id && !empty( $networks ) )
        // update_post_meta( $post_id, '_wpvmachine_affurl', $link );
    echo "1";
    exit();
}
?>