<?php
function wpvmachine_translate_text_ajax() {
	$text = trim( $_POST['text'] );
	$to = trim( $_POST['to'] );
	$from = trim( $_POST['from'] );
	if( !$text )
	    exit();
	echo wpvmachine_translate_text( $text, $from, $to );
	exit();
}

function wpvmachine_translate_text( $text, $from = 'en', $to = 'es' ) {
	include_once WPVMACHINE_DIR.'/lib/libs/translation/WPVMGTranslate.php';
	$attempts = 2;

	$tr = new WPVMGTranslate();
	$result = $tr->translate( $from, $to, $text, $attempts );
	if( $result )
		return $result;
	else
		return '0';
}

function wpvmachine_language_input( $name = 'wpvm_lang_from', $echo = 1  ) {
	$langs = wpvmachine_languages();
	$str = '<select id="'.$name.'">';
	foreach( $langs as $code => $language ) {
		$str .= '<option value="'.$code.'">'.$language.'</option>';
	}
	$str .= '</select>';
	if( $echo )
		echo $str;
}

function wpvmachine_languages() {
	$langs = array (
	    'auto' => 'Automatic',
	    'en' => 'English',
	    'es' => 'Spanish',
	    'de' => 'German',
	    'fr' => 'French',
	    'it' => 'Italian',
	    'af' => 'Afrikaans',
	    'sq' => 'Albanian',
	    'am' => 'Amharic',
	    'ar' => 'Arabic',
	    'hy' => 'Armenian',
	    'az' => 'Azerbaijani',
	    'eu' => 'Basque',
	    'be' => 'Belarusian',
	    'bn' => 'Bengali',
	    'bs' => 'Bosnian',
	    'bg' => 'Bulgarian',
	    'ca' => 'Catalan',
	    'ceb' => 'Cebuano',
	    'ny' => 'Chichewa',
	    'zh-cn' => 'Chinese Simplified',
	    'zh-tw' => 'Chinese Traditional',
	    'co' => 'Corsican',
	    'hr' => 'Croatian',
	    'cs' => 'Czech',
	    'da' => 'Danish',
	    'nl' => 'Dutch',
	    'eo' => 'Esperanto',
	    'et' => 'Estonian',
	    'tl' => 'Filipino',
	    'fi' => 'Finnish',
	    'fy' => 'Frisian',
	    'gl' => 'Galician',
	    'ka' => 'Georgian',
	    'el' => 'Greek',
	    'gu' => 'Gujarati',
	    'ht' => 'Haitian Creole',
	    'ha' => 'Hausa',
	    'haw' => 'Hawaiian',
	    'iw' => 'Hebrew',
	    'hi' => 'Hindi',
	    'hmn' => 'Hmong',
	    'hu' => 'Hungarian',
	    'is' => 'Icelandic',
	    'ig' => 'Igbo',
	    'id' => 'Indonesian',
	    'ga' => 'Irish',
	    'ja' => 'Japanese',
	    'jw' => 'Javanese',
	    'kn' => 'Kannada',
	    'kk' => 'Kazakh',
	    'km' => 'Khmer',
	    'ko' => 'Korean',
	    'ku' => 'Kurdish (Kurmanji)',
	    'ky' => 'Kyrgyz',
	    'lo' => 'Lao',
	    'la' => 'Latin',
	    'lv' => 'Latvian',
	    'lt' => 'Lithuanian',
	    'lb' => 'Luxembourgish',
	    'mk' => 'Macedonian',
	    'mg' => 'Malagasy',
	    'ms' => 'Malay',
	    'ml' => 'Malayalam',
	    'mt' => 'Maltese',
	    'mi' => 'Maori',
	    'mr' => 'Marathi',
	    'mn' => 'Mongolian',
	    'my' => 'Myanmar (Burmese)',
	    'ne' => 'Nepali',
	    'no' => 'Norwegian',
	    'ps' => 'Pashto',
	    'fa' => 'Persian',
	    'pl' => 'Polish',
	    'pt' => 'Portuguese',
	    'ma' => 'Punjabi',
	    'ro' => 'Romanian',
	    'ru' => 'Russian',
	    'sm' => 'Samoan',
	    'gd' => 'Scots Gaelic',
	    'sr' => 'Serbian',
	    'st' => 'Sesotho',
	    'sn' => 'Shona',
	    'sd' => 'Sindhi',
	    'si' => 'Sinhala',
	    'sk' => 'Slovak',
	    'sl' => 'Slovenian',
	    'so' => 'Somali',
	    'su' => 'Sundanese',
	    'sw' => 'Swahili',
	    'sv' => 'Swedish',
	    'tg' => 'Tajik',
	    'ta' => 'Tamil',
	    'te' => 'Telugu',
	    'th' => 'Thai',
	    'tr' => 'Turkish',
	    'uk' => 'Ukrainian',
	    'ur' => 'Urdu',
	    'uz' => 'Uzbek',
	    'vi' => 'Vietnamese',
	    'cy' => 'Welsh',
	    'xh' => 'Xhosa',
	    'yi' => 'Yiddish',
	    'yo' => 'Yoruba',
	    'zu' => 'Zulu'
	);
	return $langs;
}
?>