<?php
function wpvmachine_screen_newvid() {
      if (! current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
      if (! user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-backlinks-machine' ) );
      if( isset( $_GET['pid'] ) && !empty( $_GET['pid'] ) ) {
        $post_id = intval( ( $_GET['pid'] ) );
        $title = get_the_title( $post_id );
        $content = wpvmachine_get_post_content( $post_id );
        $images = wpvmachine_get_post_images( $post_id );
        $yt_title = $title;
        $yt_description = 'More info at '.get_permalink( $post_id ). "\n\n".$content;
        $language = 'en-us';
        $sex = '1';
      }
      else if( isset( $_GET['vid'] ) && !empty( $_GET['vid'] ) ) {
        $video_id = intval( ( $_GET['vid'] ) );
        $video_data = wpvmachine_get_video( $video_id );
        // var_dump($video_data);
        $post_id =  $video_data->post_id;
        $title = $video_data->title;
        $content = $video_data->texto;
        $images = json_decode( $video_data->images );
        $yt_title = $video_data->videoTitle;
        $yt_description = $video_data->videoDescription;
        $language = $video_data->voiceLanguage;
        $sex = $video_data->voiceSex;
      }
      else {
        $post_id = 0;
        $title = '';
        $content = '';
        $images = array();
        $yt_title = '';
        $yt_description = '';
        $language = 'en-us';
        $sex = '1';
      }
        ?>
        <div class="wrap">
        <?php wpvmachine_header(); ?>

        <?php if( isset( $_POST['wpvmachine_create_vid']) ) {
          $post_id = isset( $_POST['wpvmachine_post_id'] ) ? intval( $_POST['wpvmachine_post_id'] ) : '';
          $title = isset( $_POST['wpvmachine_name'] ) ? trim( stripslashes( $_POST['wpvmachine_name'] ) ) : '';
          $content = isset( $_POST['wpvmachine_content'] ) ? trim( $_POST['wpvmachine_content'] ) : '';
          $content = stripslashes( $content );
          $images = isset( $_POST['vimages'] ) ? $_POST['vimages']  : array();

          $tts = isset( $_POST['tts'] ) ? intval( $_POST['tts'] ) : 0;
          $video_language = isset( $_POST['video_language'] ) ? trim( $_POST['video_language'] ) : 'en-us';
          $voice_sex = isset( $_POST['voice_sex'] ) ? intval( $_POST['voice_sex'] ) : 0;
          $bg_music = isset( $_POST['audio'] ) ? intval( $_POST['audio'] ) : 0;
          $bg_track = isset( $_POST['track'] ) ? intval( $_POST['track'] ) : 0;

          $disable_animation = isset( $_POST['disable_animation'] ) ? intval( $_POST['disable_animation'] ) : 0;
          $video_quality = isset( $_POST['video_quality'] ) ? intval( $_POST['video_quality'] ) : 0;

          $overlay = isset( $_POST['overlay'] ) ? intval( $_POST['overlay'] ) : 0;
          $font = isset( $_POST['text_font'] ) ? intval( $_POST['text_font'] ) : 0;
          $text_color = isset( $_POST['text_color'] ) ? trim( $_POST['text_color'] ) : '#000000';
          $bg_color = isset( $_POST['bg_color'] ) ? trim( $_POST['bg_color'] ) : '#FFFFFF';

          $upload_youtube = isset( $_POST['upload_youtube'] ) ? intval( $_POST['upload_youtube'] ) : 0;
          $youtube_account = isset( $_POST['wpvm_yt_account'] ) ? intval( $_POST['wpvm_yt_account'] ) : 0;

          $youtube_title = isset( $_POST['wpvmachine_youtube_title'] ) ? trim( stripslashes( $_POST['wpvmachine_youtube_title'] ) ) : '';
          $youtube_description = isset( $_POST['wpvmachine_youtube_description'] ) ? trim( stripslashes( $_POST['wpvmachine_youtube_description'] ) ) : '';
          $youtube_privacy = isset( $_POST['yt_privacy'] ) ? trim( $_POST['yt_privacy'] ) : 'public';
          $youtube_cat = isset( $_POST['yt_cat'] ) ? intval( $_POST['yt_cat'] ) : 1;
          $youtube_tags = isset( $_POST['wpvmachine_youtube_tags'] ) ? trim( $_POST['wpvmachine_youtube_tags'] ) : '';

          if( empty( $images ) ) {
            echo 'Error: you need at least one image';
          }
          else if( empty( $content ) ) {
            echo 'Error: content cannot be empty';
          }
          else {
          $res = wpvmachine_submit_job( $title, $content, $images, $tts, $video_language, $voice_sex, $bg_music, $bg_track, $disable_animation, $video_quality, $overlay, $font, $text_color, $bg_color, $upload_youtube, $youtube_title, $youtube_description, $youtube_privacy, $youtube_cat, $youtube_tags, $youtube_account );
          // function wpvmachine_submit_job( $title, $content, $images, $tts, $language, $voice_sex, $bg_music, $bg_track, $disable_animation, $video_quality, $overlay, $font, $text_color, $bg_color, $upload_youtube, $youtube_title, $youtube_description, $youtube_privacy, $youtube_cat, $youtube_tags ) {
          // var_dump($res);
          if( empty( $res[0]) ) {
            echo '<br/><p><b>There was an error with your submission:</b> '.$res[1].'</p>';
          }
          else {
            wpvmachine_add_to_log( $post_id, $res[1], $title, $content, $images, $video_language, $upload_youtube, $youtube_title, $youtube_description );
            $settings = wpvmachine_get_plugin_settings();
            // var_dump($settings);
           // $apikey = $settings['apikey'];
            wpvmachine_success_message( $res[1] );
            // echo '<br/><br/><div class="notice notice-success is-dismissible inline"><p><i class="fa fa-check"></i> <b>Video submitted for creation</b> Once it\'s processed, you can view it <a href="'.wpvmachine_report_url( $res[1] ).'" target="_blank">here</a></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
            }
          }
          } else {
          ?>

          <h1>Create Video <small style="font-size:0.6em"><a href="https://wpvideomachine.com/support/knowledgebase/creating-a-new-video/" target="_blank">Help - how to create a video</a></small> <button type="button" class="button button-primary" style="float:right" id="wpvm-do-create-video"><i class="fas fa-video"></i> Create Video</button></h1>
          <br/>
    <form action="" method="post" id="vmsubmitv-form">

		<div id="wpvmachine-tabs" >
		    <h2 class="nav-tab-wrapper">
		        <a href="#wpvmachine-content-tab" class="nav-tab nav-tab-active"><i class="far fa-file-alt"></i> Content</a>
		        <a href="#wpvmachine-audio-tab" class="nav-tab"><i class="fa fa-volume-up"></i> Audio</a>
		        <a href="#wpvmachine-settings-tab" class="nav-tab"><i class="fa fa-video"></i> Video Settings</a>
		        <a href="#wpvmachine-style-tab" class="nav-tab"><i class="fa fa-palette"></i> Style</a>
            <a href="#wpvmachine-upload-tab" class="nav-tab"><i class="fab fa-youtube"></i> Upload</a>
            <?php if( wpvmachine_is_pro() ) { ?>
  		        <a href="#wpvmachine-sharing-tab" class="nav-tab"><i class="fa fa-share-alt"></i> Sharing</a>
            <?php } ?>
		    </h2>
		    <div style="clear:both"></div>
		    <div id="wpvmachine-content-tab" class="tab-inner" style="display:block"><?php wpvmachine_tab_content( $post_id, $title, $content, $images );?></div>
        <div id="wpvmachine-audio-tab" class="tab-inner"><?php wpvmachine_tab_audio( $language, $sex );?></div>
        <div id="wpvmachine-settings-tab" class="tab-inner"><?php wpvmachine_tab_settings();?></div>
        <div id="wpvmachine-style-tab" class="tab-inner"><?php wpvmachine_tab_style();?></div>
        <div id="wpvmachine-upload-tab" class="tab-inner"><?php wpvmachine_tab_upload( $yt_title, $yt_description );?></div>
        <?php if( wpvmachine_is_pro() ) { ?>
		      <div id="wpvmachine-sharing-tab" class="tab-inner"><?php wpvmachine_tab_sharing();?></div>
        <?php } ?>

    </div>

    <table class="form-table">
      <tr valign="top">
        <th scope="row">&nbsp;</th>
        <td>
          <input type="hidden" name="wpvmachine_post_id" value="<?php echo $post_id;?>">
          <input type="hidden" name="wpvmachine_create_vid" value="1">
          <button type="submit" class="button button-primary" id="wpvm-createvid"><i class="fas fa-video"></i> Create Video</button></td>
        </td>
      </tr>
    </table>

            </form>
            <?php if( wpvmachine_is_pro() ) { ?>
              <?php wpvmachine_spin_modal(); ?>
              <?php wpvmachine_spining_modal(); ?>
              <?php wpvmachine_affiliate_modal(); ?>
              <?php wpvmachine_translate_modal(); ?>
              <?php wpvmachine_content_modal(); ?>
              <?php wpvmachine_trends_modal(); ?>
            <?php } ?>
          <?php } ?>
        </div>
<?php
}

function wpvmachine_post_images( $images = array() ) {
?>
  <div id="avm-post-images">
    <div class="gallery1">
      <div id="images-list">
        <ul class="reorder_ul reorder-photos-list">
        <?php
        if( !empty( $images ) ) {
          $i = 1;

          foreach( $images as $key => $image ) {
            echo '<li id="image_li_'.$key.'" class="ui-sortable-handle image_link">
                          <button type="button" class="button button-secondary btn-delete-img">X</button>
                              <img src="'.$image.'" alt="">
                              <input type="hidden" name="vimages['.($i).']" value="'.$image.'" />
                      </li>';
            $i++;
                    }
          }
        // }

        ?>
      </ul>
      </div>
      <!-- id="add-image" -->
        <a  href="#" type="button" class="button button-secondary wpvmachine_img_upload"> <i class="fa fa-plus"></i> Add Image</a>
        <p><small>Tip: Click on "Add Image" and select "WP Video Machine" on the left to search our library of copyright free images.</small></p>
    </div>
  </div>
<?php
}

// tabs

        function wpvmachine_tab_content( $post_id, $title, $content, $images ) {
          ?>
          <table class="form-table">
            <tbody>
            <tr valign="top">
              <th scope="row">Video Name</th>
              <td>
                <input type="text" class="large-text" name="wpvmachine_name" id="wpvmachine_name" placeholder="Post / Video name" value="<?php echo $title;?>"><br>
                <span class="description">The name for your video</span>
              </td>
            </tr>
            <tr valign="top">
              <th scope="row">Video Content</th>
              <td>
                <textarea name="wpvmachine_content" id="wpvmachine_content" cols="30" rows="10" class="large-text" placeholder="Post / Video content"><?php echo $content;?></textarea>
                <span class="description">The content for the video (this will be read aloud and/or displayed on screen). Maximum 8000 characters.</span><br/>
                <?php if (wpvmachine_is_pro() ) { ?>
                  <button type="button" class="button button-secondary" id="wpvm-spin" style="float:right;margin-top:8px;margin-right:12px"><i class="fas fa-spinner"></i> Spin Text</button>
                  <button type="button" class="button button-secondary" id="wpvm-translate" style="float:right;margin-top:8px;margin-right:12px"><i class="fas fa-language"></i> Translate Text</button>
                  <button type="button" class="button button-secondary" id="wpvm-content" style="float:right;margin-top:8px;margin-right:12px"><i class="far fa-file-alt"></i> Get Content</button>
                  <button type="button" class="button button-secondary" id="wpvm-trends" style="float:right;margin-top:8px;margin-right:12px"><i class="far fa-lightbulb"></i> Get Topic Ideas</button>
                  <div style="clear:both"></div>
                <?php } ?>
              </td>
            </tr>
          </tbody>
        </table>
        <h3>Images:</h3>
        <?php /*$images = array( 'http://localhost/test/img.png', 'http://localhost/test/img2.png')*/ ?>
        <?php wpvmachine_post_images( $images ); ?>
          <?php
        }
        function  wpvmachine_tab_audio() {
          ?>
          <table class="form-table">
            <?php wpvmachine_field_checkbox( 'Convert Text to Speech', 'tts', 1, false, 'wpvmachine_tts', '
Check to convert your text to speech', '' ); ?>
            <?php
              $languages = wpvmachine_get_languages( );

              wpvmachine_field_select( 'Language', 'video_language', '', $languages, 'video_language', 'The language used to read the post', '', '', 'wpvmachine_tts_row', false );
              $sexes = wpvmachine_get_sexes( );
              wpvmachine_field_select( 'Sex', 'voice_sex', '', $sexes, 'voice_sex', 'For the voiceover', '', '', 'wpvmachine_tts_row', false );
              wpvmachine_field_checkbox( 'Add Background Music', 'audio', 1, false, 'wpvmachine_audio', '
              Check to add background music to your video', '' );
              $tracks = wpvmachine_get_audios( );
              wpvmachine_field_select( 'Audio Track', 'track', '', $tracks, false, 'The language used to read the post', '', '', 'wpvmachine_audio_row', false );
            ?>
      </table>
          <?php
        }
        function  wpvmachine_tab_settings() {
          ?>
            <table class="form-table">
              <?php wpvmachine_field_checkbox( 'Disable Video Animations', 'disable_animation', 0, false, 'wpvmachine_disable_animation', '
  Check this to disable video pan/zoom (makes videos less eye-catching, but can increase quality with smaller images)', '' ); ?>
              <?php
                $qualities = wpvmachine_get_video_qualities( );
                wpvmachine_field_select( 'Video Quality', 'video_quality', '', $qualities );
              ?>
        </table>
          <?php
        }
        function  wpvmachine_tab_style() {
          ?>
          <table class="form-table">
            <?php wpvmachine_field_checkbox( 'Add text overlay', 'overlay', true, false, 'wpvmachine_overlay', '
            Check to display the video content as text in the video', '' ); ?>
            <?php
              $fonts = wpvmachine_get_text_fonts( );
              wpvmachine_field_select( 'Font', 'text_font', '', $fonts, false, '', '', '', 'wpvmachine_overlay_row', false );
              wpvmachine_field_color( 'Text Color', 'text_color', '#000000', false, 1, '', '', '', 'wpvmachine_overlay_row' );
              wpvmachine_field_color( 'Background Color', 'bg_color', '#ffffff', false, 1, '', '', '', 'wpvmachine_overlay_row' );
            ?>
          </table>
          <?php
        }
        function  wpvmachine_tab_upload( $yt_title, $yt_description ) {
          ?>
            <table class="form-table">
              <tbody>
              <tr valign="top">
                <th scope="row">Upload to Youtube</th>
                <td>
                  <input type="checkbox" name="upload_youtube" value="1" id="upload_youtube">
                  <span class="description">Check this to upload the generated video to youtube (make sure to previously authorize your Youtube account or it won't work</span>
                </td>
              </tr>
              <?php if( !wpvmachine_youtube_valid() ) { ?>
                <tr valign="top" style="display:none" class="yt-settings">
                  <td colspan = "2">
                    <div class="notice notice-error is-dismissible inline"><p><i class="fa fa-times"></i> In order to upload videos to Youtube, you need to authorize your Youtube Account.</p>
                    <p><a href="<?php echo admin_url( 'admin.php?page=wp-video-machine-settings');?>">Click here</a> to enter your Youtube Authorization details (you only need to do it once).</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>
                  </td>
                </tr>
              <?php } else { ?>
                <?php if( wpvmachine_is_pro() ) { ?>
                <tr valign="top" style="display:none" class="yt-settings">
                  <th scope="row">Youtube Account</th>
                  <td>
                    <?php wpvmachine_yt_accounts_select(); ?><br>
                    <span class="description">Your Youtube account (you can add more in the plugin settings)</span>
                  </td>
                </tr>
              <?php }  else { ?>
                  <input type="hidden" name="wpvm_yt_account" value="0">
              <?php } ?>
              <tr valign="top" style="display:none" class="yt-settings">
                <th scope="row">Youtube Title</th>
                <td>
                  <input type="text" class="large-text" name="wpvmachine_youtube_title" id="wpvmachine_youtube_title" placeholder="Youtube video title" value="<?php echo $yt_title;?>"><br>
                  <span class="description">The title for the Youtube video (max 100 characters)</span>
                </td>
              </tr>
              <tr valign="top" style="display:none" class="yt-settings">
                <th scope="row">Youtube Description</th>
                <td>
                  <textarea name="wpvmachine_youtube_description" id="wpvmachine_youtube_description" cols="30" rows="10" class="large-text" placeholder="Youtube video description"><?php echo $yt_description;?></textarea>
                  <span class="description">The description for the Youtube video</span>
                  <?php if (wpvmachine_is_pro() ) { ?>
                    <button type="button" class="button button-secondary" id="wpvm-affiliate" style="float:right;clear:right;margin-top:8px;margin-right:12px"><i class="fas fa-dollar-sign"></i> Add Affiliate Links</button>
                  <?php } ?>
                </td>
              </tr>
              <?php
                $fonts = wpvmachine_get_privacies( );
                wpvmachine_field_select( 'Privacy', 'yt_privacy', '', $fonts, false, '', '', '', 'yt-settings', true );

                $fonts = wpvmachine_get_yt_categories( );
                wpvmachine_field_select( 'Category', 'yt_cat', '', $fonts, false, '', '', '', 'yt-settings', true );
              ?>
              <tr valign="top" style="display:none" class="yt-settings">
                <th scope="row">Tags<br/><br/>
                <button type="button" class="button button-secondary" id="search-tags-auto"><i class="fas fa-magic"></i> Get Automatic Tags</button>
                <?php if( wpvmachine_is_pro() ) { ?>
                  <br/>
                  <br/>
                <button type="button" class="button button-secondary" id="search-tags-manual"><i class="fas fa-tag"></i> Search Tags</button>
                <?php } ?>
              </th>
                <td>
                  <input type="text" class="large-text wpvmach_tags" name="wpvmachine_youtube_tags" id="wpvmachine_youtube_tags" placeholder="Youtube tags" value=""><br>
                  <span class="description">The tags for the Youtube video</span>
                  <br/>
                </td>
              </tr>
              <?php } ?>
            </tbody>
          </table>
          <?php if( wpvmachine_is_pro() ) { ?>
          <table class="form-table">
            <tbody>
            <tr valign="top">
              <th scope="row">Upload to Vimeo</th>
              <td>
                <input type="checkbox" name="upload_vimeo" value="1" id="upload_vimeo">
                <span class="description">Check this to upload the generated video to Vimeo</span>
              </td>
            </tr>
          </tbody>
          </table>
          <table class="form-table">
            <tbody>
            <tr valign="top">
              <th scope="row">Upload to Dailymotion</th>
              <td>
                <input type="checkbox" name="upload_dailytmotion" value="1" id="upload_dailytmotion">
                <span class="description">Check this to upload the generated video to Dailymotion</span>
              </td>
            </tr>
          </tbody>
          </table>
          <?php
          }
          wpvmachine_tags_modal();
        }
        function  wpvmachine_tab_sharing() {
          ?>
          <p>Share the URL of the Youtube video (after upload) to:</p>
          <?php wpvmachine_share_list(); ?>
          <?php
        }
  // Data

  function wpvmachine_get_languages() {
    return array(
      array( 'value' => 'en-us', 'label' => 'US English' ),
      array( 'value' => 'en-gb', 'label' => 'UK English' ),
      array( 'value' => 'es-es', 'label' => 'Castilian Spanish' ),
      array( 'value' => 'es-la', 'label' => 'Latin American Spanish' ),
      array( 'value' => 'es-us', 'label' => 'North American Spanish' ),
      array( 'value' => 'fr-fr', 'label' => 'French' ),
      array( 'value' => 'de-de', 'label' => 'German' ),
      array( 'value' => 'it-it', 'label' => 'Italian' ),
      array( 'value' => 'ja-jp', 'label' => 'Japanese' ),
      array( 'value' => 'pt-br', 'label' => 'Brazilian Portuguese' ),
    );
  }

  function wpvmachine_sex_str( $num, $echo = 0 ) {
    $voice = 'Male';
    if( $num )
      $voice = 'Female';
    if( $echo )
      echo $voice;
    return $voice;
  }

  function wpvmachine_get_sexes( ) {
    return array( array( 'value' => 1, 'label' => 'Female' ), array( 'value' => 0, 'label' => 'Male' ) );
  }

  function wpvmachine_get_privacies( ) {
    return array( array( 'value' => 'public', 'label' => 'Public' ), array( 'value' => 'private', 'label' => 'Private' ), array( 'value' => 'unlisted', 'label' => 'Unlisted' ) );
  }

  function wpvmachine_get_yt_categories( ) {
    return array(
      array ('value' => 1, 'label' => "Film & Animation"),
      array ('value' => 2, 'label' => "Autos & Vehicles"),
      array ('value' => 3, 'label' => "Music"),
      array ('value' => 15, 'label' => "Pets & Animals"),
      array ('value' => 16, 'label' => "Sports"),
      array ('value' => 19, 'label' => "Travel & Events"),
      array ('value' => 20, 'label' => "Gaming"),
      array ('value' => 22, 'label' => "People & Blogs"),
      array ('value' => 23, 'label' => "Comedy"),
      array ('value' => 24, 'label' => "Entertainment"),
      array ('value' => 25, 'label' => "News & Politics"),
      array ('value' => 26, 'label' => "Howto & Style"),
      array ('value' => 27, 'label' => "Education"),
      array ('value' => 28, 'label' => "Science & Technology"),
      array ('value' => 29, 'label' => "Nonprofits & Activism")
    );
  }

  function wpvmachine_get_audios( ) {
    return array(
      array( 'value' => '0', 'label' => 'Random track' ),
      array( 'value' => '1', 'label' => 'All Mixed Up' ) ,
      array( 'value' => '2', 'label' => 'Almost Summer' ) ,
      array( 'value' => '3', 'label' => 'Background' ) ,
      array( 'value' => '4', 'label' => 'Beautiful' ) ,
      array( 'value' => '5', 'label' => 'City Life' ) ,
      array( 'value' => '6', 'label' => 'Corporate Vision' ) ,
      array( 'value' => '7', 'label' => 'Dawn Raid' ) ,
      array( 'value' => '8', 'label' => 'Deep Chill' ),
      array( 'value' => '9', 'label' => 'Gangsta Land' ),
      array( 'value' => '10', 'label' => 'Innovation' ),
      array( 'value' => '11', 'label' => 'Internal Power' ),
      array( 'value' => '12', 'label' => 'Reflections' ),
      array( 'value' => '13', 'label' => 'Resistance' ),
      array( 'value' => '14', 'label' => 'Spring to Life' ),
      array( 'value' => '14', 'label' => 'More Tracks...' ),
    );
  }

  function wpvmachine_get_video_qualities( ) {
    return array(
      array( 'value' => '0', 'label' => 'Standard Definition' ),
      array( 'value' => '1', 'label' => 'HD (720p)' ) ,
      array( 'value' => '2', 'label' => 'HD (1080p)' )
    );
  }

  function wpvmachine_get_logo_positions() {
    return array(
      array( 'value' => '0', 'label' => 'Bottom Right' ),
      array( 'value' => '1', 'label' => 'Bottom Left' ) ,
      array( 'value' => '2', 'label' => 'Top Right' ),
      array( 'value' => '3', 'label' => 'Top Left' )
    );
  }

  function wpvmachine_get_text_fonts() {
    return array(
      array( 'value' => '0', 'label' => 'Roboto' ),
      array( 'value' => '1', 'label' => 'Caviar Dreams' ),
      array( 'value' => '2', 'label' => 'Droid Sans' ),
      array( 'value' => '3', 'label' => 'Great Vibes' ),
      array( 'value' => '4', 'label' => 'Kaushan Script' ),
      array( 'value' => '5', 'label' => 'Lobster' ),
      array( 'value' => '6', 'label' => 'Open Sans' ),
      array( 'value' => '7', 'label' => 'Pacifico' ),
      array( 'value' => '8', 'label' => 'Quick Sand' ),
      array( 'value' => '9', 'label' => 'More fonts...' ),
    );
  }


  function wpvmachine_share_list( $name = 'wpvmachine_share', $values = array( 0, 0, 0, 0, 0, 0 )  ) {
    $i = 0;
  ?>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_share_nw" value="1" name="<?php echo $name.'_facebook';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-facebook-f"></i> Facebook</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_share_nw" value="1" name="<?php echo $name.'_twitter';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-twitter"></i> Twitter</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_share_nw" value="1" name="<?php echo $name.'_medium';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-medium"></i> Medium</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_share_nw" value="1" name="<?php echo $name.'_tumblr';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-tumblr"></i> Tumblr</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_share_nw" value="1" name="<?php echo $name.'_linkedin';?>" <?php checked( $values[$i++]);?> /> <i class="fab fa-linkedin"></i> Linkedin</label>
  <label class="shr-link"><input type="checkbox" class="wpvmachine_share_nw" value="1" name="<?php echo $name.'_buffer';?>" <?php checked( $values[$i++]);?> /> <i class="fas fa-share-alt"></i> Buffer</label>
  <?php
}

function wpvmachine_spin_modal() {
?>
  <div id="avmspin-modal" class="bmmodal" style="display:none">
    <h3>Spin text using: </h3>
    <?php
      // include_
      $valid_spinners = wpvmachine_get_valid_spinners();
      if( $valid_spinners == false ) {
        wpvmachine_error_no_spinners();
      }
      else {
        echo '<p>Spin text using:</p>';
        // var_dump($valid_spinners);
        $spinners = wpvmachine_get_spinners();
        echo '<table class="form-table">';
        wpvmachine_field_select( 'Spinner', 'spinner', 0, $spinners, 'spinner' );
        echo '</table>';
        // dashboardx_select_field( 'spinner', '0', 'Spinner', $spinners, '', false, false, false, true );
        ?>
        <br/>
        <script>
          jQuery(document).ready(function() {
            <?php
              for( $i= 0; $i< 4; $i++ ) {
                if( !$valid_spinners[$i] ) {
                  echo 'jQuery(\'#spinner\').children(\'option[value="'.$i.'"]\').attr(\'disabled\', true);'."\n";
                }
              }
              ?>
          });

        </script>
        <?php
      }
    ?>

    <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Close</button>
    <?php if( $valid_spinners ) { ?>
      <button type="button" class="button button-primary" id="btn-do-spin-text"><i class="fas fa-check"></i> Spin text</button>
    <?php } ?>
  </div>
<?php
}

function wpvmachine_spining_modal() {
?>
  <div id="avmspin-modal2" class="bm-modal long-modal" style="display:none">
    <h3>Original text: </h3>
    <textarea id="spin-original" cols="30" rows="10" class="lg-textarea"></textarea>

    <h3>Spun text: </h3>
    <textarea id="spin-spun" cols="30" rows="10" class="lg-textarea"></textarea>
    <br/>
    <br/>
    <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Keep Original</button>
    <button type="button" class="button button-primary" id="btn-use-spun-text"><i class="fas fa-check"></i> Use Spun Text</button>
  </div>
<?php
}


function wpvmachine_affiliate_modal() {
?>
  <div id="avmaffiliate-modal" class="bm-modal med-modal" style="display:none">
    <h3>Search keyword: </h3>
    <input type="text" id="wpvm-aff-keyword" class="med-textarea" placeholder="Enter a keyword to search" /> <button type="button" class="button button-primary" id="btn-search-aff-link"><i class="fas fa-search"></i> Search</button>
    <br/>
      <div id="affiliate-tab-list" style="display:none">
      <?php wpvmachine_aff_tabs( 'clickbank' ); ?>
      </div>
        <div id="affiliate-results"></div>
      <br/>
      <br/>
    <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Cancel</button>
  </div>
<?php
}

function wpvmachine_translate_modal() {
?>
  <div id="avmtranslate-modal" class="bmmodal" style="display:none">
    <h3>Translate text: </h3>
    <table>
      <tr><th>From</th><td><?php wpvmachine_language_input( 'wpvm_lang_from' );?></td></tr>
      <tr><th>To</th><td><?php wpvmachine_language_input( 'wpvm_lang_to' );?></td></tr>
    </table>
    <br/>
    <br/>
    <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Close</button>
    <button type="button" class="button button-primary" id="btn-do-translate-text"><i class="fas fa-language"></i> Translate text</button>
  </div>
<?php
}

function wpvmachine_tags_modal() {
?>
  <div id="avmtags-modal" class="bm-modal med-modal" style="display:none">
    <h3>Search keyword: </h3>
    <input type="text" id="wpvm-tag-keyword" class="med-textarea" placeholder="Enter a keyword to search" /> <button type="button" class="button button-primary" id="btn-search-tag"><i class="fas fa-search"></i> Search</button>
    <br/>
      <div id="tags-tab-list" style="display:none">
      <?php wpvmachine_tags_tabs( 'google' ); ?>
      <div style="clear:both"></div>
      </div>
        <div id="tags-results"></div>
      <div style="clear:both"></div>
      <br/>
      <br/>
    <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Cancel</button>
    <button type="button" class="button button-primary" id="btn-do-insert-tags" style="display:none"><i class="fas fa-tag"></i> Use selected tags</button>
  </div>
<?php
}

function wpvmachine_content_modal() {
?>
<div id="avmcontent-modal" class="bm-modal med-modal" style="display:none">
  <h3>Search keyword: </h3>
  <div class="wpvmachine-row">
  <input type="text" id="wpvmachine_content_keyword" class="med-textarea" placeholder="Enter a keyword to search" /> <?php wpvmachine_contents_input( 'wpvmachine_content_service' )?> <button type="button" class="button button-primary" id="btn-search-content"> ;<i class="fas fa-search"></i> Search</button>
  </div>
  <br/>
    <div id="wpvmachine_content_list" style="display:none"></div>
    <br/>
    <br/>
  <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Cancel</button>
  <button type="button" class="button button-primary" id="btn-do-insert-content" style="display:none"><i class="fas fa-tag"></i> Use selected content</button>
</div>
<?php
}

function wpvmachine_trends_modal() {
?>
<div id="avmtrends-modal" class="bm-modal med-modal" style="display:none">
  <div class="wpvmachine-row">
    <h3>Daily Trends</h3>
    <button type="button" class="button button-primary" id="btn-do-search-trends"><i class="fas fa-chart-line"></i> Search trends</button>
  </div>
  <br/>
    <div id="wpvmachine_trends_list" style="display:none"></div>
    <br/>
    <br/>
  <button type="button" class="button button-secondary btn-close-vmmodal"><i class="fas fa-times"></i> Cancel</button>
</div>
<?php
}

function wpvmachine_success_message( $job_id = 0 ) {
  echo '<br/><br/><div class="notice notice-success is-dismissible inline"><p><i class="fa fa-check"></i> <b>Video submitted for creation</b> Once it\'s processed, you can view it <a href="'.wpvmachine_report_url( $job_id ).'" target="_blank">here</a></p>
  <p>It can take anywhere from 5 minutes to 30 minutes for your video to be created. It depends on the length of the content and images / music / voice you have selected.</p>
  <p>Also if there are too many users trying to create videos at the same time, your video will get queued and it can take a couple hours so please be patient and come back later to check this page</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
}
?>